Index: editwin.c
===================================================================
--- editwin.c	(revision b2c1bd487feab1fdd38e282d70efa20f4de0635a)
+++ editwin.c	(revision cc6f009750d9fa16a07d5f504a57c299f6a1d646)
@@ -143,10 +143,9 @@
   e->buffy=0;
   owl_editwin_overwrite_string(e, text);
-  owl_editwin_overwrite_char(e, '\0');
   e->lock=strlen(text);
   /* if (text[e->lock-1]=='\n') e->lock--; */
-  /*  e->buffx=x; */
-  /*  e->buffy=y; */
-  _owl_editwin_set_xy_by_index(e, e->lock);
+  e->buffx=x;
+  e->buffy=y;
+  owl_editwin_adjust_for_locktext(e);
   owl_editwin_redisplay(e, 0);
 }
@@ -256,90 +255,55 @@
 
   /* start at topline */
-  ptr1 = e->buff;
-  for (i = 0; i < e->topline; i++) {
-    ptr2 = strchr(ptr1, '\n');
+  ptr1=e->buff;
+  for (i=0; i<e->topline; i++) {
+    ptr2=strchr(ptr1, '\n');
     if (!ptr2) {
       /* we're already on the last line */
       break;
     }
-    ptr1 = ptr2 + 1;
+    ptr1=ptr2+1;
   }
   /* ptr1 now stores the starting point */
 
   /* find the ending point and store it in ptr3 */
-  ptr2 = ptr1;
-  ptr3 = ptr1;
-  for (i = 0; i < e->winlines; i++) {
-    ptr3 = strchr(ptr2, '\n');
+  ptr2=ptr1;
+  ptr3=ptr1;
+  for (i=0; i<e->winlines; i++) {
+    ptr3=strchr(ptr2, '\n');
     if (!ptr3) {
       /* we've hit the last line */
       /* print everything to the end */
-      ptr3 = e->buff + e->bufflen - 1;
+      ptr3=e->buff+e->bufflen-1;
       ptr3--;
       break;
     }
-    ptr2 = ptr3 + 1;
-  }
-  ptr3 += 2;
-
-  buff = owl_malloc(ptr3 - ptr1 + 50);
-  strncpy(buff, ptr1, ptr3 - ptr1);
-  buff[ptr3 - ptr1] = '\0';
-  if (e->echochar == '\0') {
+    ptr2=ptr3+1;
+  }
+  ptr3+=2;
+
+  buff=owl_malloc(ptr3-ptr1+50);
+  strncpy(buff, ptr1, ptr3-ptr1);
+  buff[ptr3-ptr1]='\0';
+  if (e->echochar=='\0') {
     waddstr(e->curswin, buff);
   } else {
     /* translate to echochar, *except* for the locktext */
     int len;
-    int dolocklen = e->lock - (ptr1 - e->buff);
-    char *locktext;
-    char tmp = e->buff[dolocklen];
-
-    e->buff[dolocklen] = '\0';
-    locktext = owl_strdup(e->buff);
-    e->buff[dolocklen] = tmp;
-
-    waddstr(e->curswin, locktext);
-    
-    len = strlen(buff);
-    for (i = 0; i < len-dolocklen; i++) {
+    int dolocklen=e->lock-(ptr1-e->buff);
+
+    for (i=0; i<dolocklen; i++) {
+      waddch(e->curswin, buff[i]);
+    }
+    len=strlen(buff);
+    for (i=0; i<len-dolocklen; i++) {
       waddch(e->curswin, e->echochar);
     }
   }
-  wmove(e->curswin, e->buffy-e->topline, e->buffx + _owl_editwin_cursor_adjustment(e));
+  wmove(e->curswin, e->buffy-e->topline, e->buffx);
   wnoutrefresh(e->curswin);
-  if (update == 1) {
+  if (update==1) {
     doupdate();
   }
   owl_free(buff);
-}
-
-/* Remove n bytes at cursor. */
-void _owl_editwin_remove_bytes(owl_editwin *e, int n) /*noproto*/
-{
-  int i = _owl_editwin_get_index_from_xy(e) + n;
-  for (; i < e->bufflen; i++) {
-    e->buff[i-n] = e->buff[i];
-  }
-  
-  e->bufflen -= n;
-  e->buff[e->bufflen] = '\0';
-}
-
-/* Insert n bytes at cursor.*/
-void _owl_editwin_insert_bytes(owl_editwin *e, int n) /*noproto*/
-{
-  int i, z;
-  
-  if ((e->bufflen + n) > (e->allocated - 5)) {
-    _owl_editwin_addspace(e);
-  }
-
-  e->bufflen += n;
-  e->buff[e->bufflen] = '\0';
-  
-  z = _owl_editwin_get_index_from_xy(e);
-  for (i = e->bufflen - 1; i > z; i--) {
-    e->buff[i] = e->buff[i - n];
-  }
 }
 
@@ -351,33 +315,24 @@
 int _owl_editwin_linewrap_word(owl_editwin *e)
 {
-  int x, y;
-  int i;
-  char *ptr1, *start;
-  gunichar c;
-
-  /* saving values */
-  x = e->buffx;
-  y = e->buffy;
-  start = e->buff + e->lock;
-
-  ptr1 = e->buff + _owl_editwin_get_index_from_xy(e);
-  ptr1 = g_utf8_find_prev_char(start, ptr1);
-
-  while (ptr1) {
-    c = g_utf8_get_char(ptr1);
-    if (owl_util_can_break_after(c)) {
-      if (c != ' ') {
-        i = ptr1 - e->buff;
-        _owl_editwin_set_xy_by_index(e, i);
-        _owl_editwin_insert_bytes(e, 1);
-        /* _owl_editwin_insert_bytes may move e->buff. */
-        ptr1 = e->buff + i;
-      }
-      *ptr1 = '\n';
-      return 0;
-    }
-    ptr1 = g_utf8_find_prev_char(start, ptr1);
-  }
-  return -1;
+  int i, z;
+
+  z=_owl_editwin_get_index_from_xy(e);
+  /* move back and line wrap the previous word */
+  for (i=z-1; ; i--) {
+    /* move back until you find a space or hit the beginning of the line */
+    if (e->buff[i]==' ') {
+      /* replace the space with a newline */
+      e->buff[i]='\n';
+      e->buffy++;
+      e->buffx=z-i-1;
+      /* were we on the last line */
+      return(0);
+    } else if (e->buff[i]=='\n' || i<=e->lock) {
+      /* we hit the begginning of the line or the buffer, we cannot
+       * wrap.
+       */
+      return(-1);
+    }
+  }
 }
 
@@ -385,16 +340,15 @@
  * characters over)
  */
-void owl_editwin_insert_char(owl_editwin *e, gunichar c)
-{
-  int z, i, ret, len;
-  char tmp[6];
-  memset(tmp, '\0', 6);
+void owl_editwin_insert_char(owl_editwin *e, char c)
+{
+  
+  int z, i, ret;
 
   /* \r is \n */
-  if (c == '\r') {
-    c = '\n';
-  }
-
-  if (c == '\n' && e->style == OWL_EDITWIN_STYLE_ONELINE) {
+  if (c=='\r') {
+    c='\n';
+  }
+
+  if (c=='\n' && e->style==OWL_EDITWIN_STYLE_ONELINE) {
     /* perhaps later this will change some state that allows the string
        to be read */
@@ -402,19 +356,16 @@
   }
 
-  g_unichar_to_utf8(c, tmp);
-  len = strlen(tmp);
-
   /* make sure there is enough memory for the new text */
-  if ((e->bufflen + len) > (e->allocated - 5)) {
+  if ((e->bufflen+1) > (e->allocated-5)) {
     _owl_editwin_addspace(e);
   }
 
   /* get the insertion point */
-  z = _owl_editwin_get_index_from_xy(e);
+  z=_owl_editwin_get_index_from_xy(e);
 
   /* If we're going to insert at the last column do word wrapping, unless it's a \n */
-  if ((e->buffx + 1 == e->wrapcol) && (c != '\n')) {
-    ret = _owl_editwin_linewrap_word(e);
-    if (ret == -1) {
+  if ((e->buffx+1==e->wrapcol) && (c!='\n')) {
+    ret=_owl_editwin_linewrap_word(e);
+    if (ret==-1) {
       /* we couldn't wrap, insert a hard newline instead */
       owl_editwin_insert_char(e, '\n');
@@ -422,36 +373,37 @@
   }
 
+  z=_owl_editwin_get_index_from_xy(e);
   /* shift all the other characters right */
-  if (z != e->bufflen) {
-    _owl_editwin_insert_bytes(e, len);
-  }
-
-  /* insert the new character */
-  for(i = 0; i < len; i++) {
-    e->buff[z + i] = tmp[i];
-  }
+  for (i=e->bufflen; i>z; i--) {
+    e->buff[i]=e->buff[i-1];
+  }
+
+  /* insert the new one */
+  e->buff[z]=c;
 
   /* housekeeping */
-  e->bufflen += len;
-  e->buff[e->bufflen] = '\0';
+  e->bufflen++;
+  e->buff[e->bufflen]='\0';
+
+  /* advance the cursor */
+  if (c=='\n') {
+    e->buffx=0;
+    e->buffy++;
+  } else {
+    e->buffx++;
+  }
+}
+
+/* overwrite the character at the current point with 'c' */
+void owl_editwin_overwrite_char(owl_editwin *e, char c)
+{
+  int z;
   
-  /* advance the cursor */
-  z += len;
-  _owl_editwin_set_xy_by_index(e, z);
-}
-
-/* overwrite the character at the current point with 'c' */
-void owl_editwin_overwrite_char(owl_editwin *e, gunichar c)
-{
-  int z, oldlen, newlen, i;
-  char tmp[6];
-  memset(tmp, '\0', 6);
-
   /* \r is \n */
-  if (c == '\r') {
-    c = '\n';
-  }
-  
-  if (c == '\n' && e->style == OWL_EDITWIN_STYLE_ONELINE) {
+  if (c=='\r') {
+    c='\n';
+  }
+
+  if (c=='\n' && e->style==OWL_EDITWIN_STYLE_ONELINE) {
     /* perhaps later this will change some state that allows the string
        to be read */
@@ -459,40 +411,29 @@
   }
 
-  g_unichar_to_utf8(c, tmp);
-  newlen = strlen(tmp);
-
-  z = _owl_editwin_get_index_from_xy(e);
-  {
-    char *t = g_utf8_find_next_char(e->buff + z, NULL);
-    oldlen = (t ? (t - (e->buff + z)) : 0);
-  }
-
-  /* only if we are at the end of the buffer do we create new space here */
-  if (z == e->bufflen) {
-    if ((e->bufflen+newlen) > (e->allocated-5)) {
+  z=_owl_editwin_get_index_from_xy(e);
+
+  /* only if we are at the end of the buffer do we create new space */
+  if (z==e->bufflen) {
+    if ((e->bufflen+1) > (e->allocated-5)) {
       _owl_editwin_addspace(e);
     }
   }
-  /* if not at the end of the buffer, adjust based in char size difference. */ 
-  else if (oldlen > newlen) {
-    _owl_editwin_remove_bytes(e, oldlen-newlen);
-  }
-  else /* oldlen < newlen */ {
-    _owl_editwin_insert_bytes(e, newlen-oldlen);
-  }
-  /* Overwrite the old char*/
-  for (i = 0; i < newlen; i++) {
-    e->buff[z+i] = tmp[i];
-  }
-       
-  /* housekeeping */
-  if (z == e->bufflen) {
-    e->bufflen += newlen;
-    e->buff[e->bufflen] = '\0';
-  }
   
+  e->buff[z]=c;
+
+  /* housekeeping if we are at the end of the buffer */
+  if (z==e->bufflen) {
+    e->bufflen++;
+    e->buff[e->bufflen]='\0';
+  }
+
   /* advance the cursor */
-  z += newlen;
-  _owl_editwin_set_xy_by_index(e, z);
+  if (c=='\n') {
+    e->buffx=0;
+    e->buffy++;
+  } else {
+    e->buffx++;
+  }
+
 }
 
@@ -502,23 +443,18 @@
 void owl_editwin_delete_char(owl_editwin *e)
 {
-  int z;
-  char *p1, *p2;
-  gunichar c;
-
-  if (e->bufflen == 0) return;
+  int z, i;
+
+  if (e->bufflen==0) return;
   
   /* get the deletion point */
-  z = _owl_editwin_get_index_from_xy(e);
-
-  if (z == e->bufflen) return;
-
-  p1 = e->buff + z;
-  p2 = g_utf8_next_char(p1);
-  c = g_utf8_get_char(p2);
-  while (g_unichar_ismark(c)) {
-    p2 = g_utf8_next_char(p2);
-    c = g_utf8_get_char(p2);
-  }
-  _owl_editwin_remove_bytes(e, p2-p1);
+  z=_owl_editwin_get_index_from_xy(e);
+
+  if (z==e->bufflen) return;
+
+  for (i=z; i<e->bufflen; i++) {
+    e->buff[i]=e->buff[i+1];
+  }
+  e->bufflen--;
+  e->buff[e->bufflen]='\0';
 }
 
@@ -531,43 +467,25 @@
 {
   int z;
-  char *p1, *p2, *p3, *tmp;
-
-  if (e->bufflen == 0) return;
+  char tmp;
+
+  if (e->bufflen==0) return;
   
   /* get the cursor point */
-  z = _owl_editwin_get_index_from_xy(e);
-
-  if (z == e->bufflen) {
+  z=_owl_editwin_get_index_from_xy(e);
+
+  if (z==e->bufflen) {
     /* point is after last character */
     z--;
   }  
 
-  if (z - 1 < e->lock) {
+  if (z-1 < e->lock) {
     /* point is at beginning of buffer, do nothing */
     return;
   }
 
-  /* Transpose two utf-8 unicode glyphs. */
-  p1 = e->buff + z;
-
-  p2 = g_utf8_find_next_char(p1, NULL);
-  while (p2 != NULL && g_unichar_ismark(g_utf8_get_char(p2))) {
-    p2 = g_utf8_find_next_char(p2, NULL);
-  }
-  if (p2 == NULL) return;
-
-  p3 = g_utf8_find_prev_char(e->buff, p1);
-  while (p3 != NULL && g_unichar_ismark(g_utf8_get_char(p3))) {
-    p3 = g_utf8_find_prev_char(p3, NULL);
-  }
-  if (p3 == NULL) return;
-
-  tmp = owl_malloc(p2 - p3 + 5);
-  *tmp = '\0';
-  strncat(tmp, p1, p2 - p1);
-  strncat(tmp, p3, p1 - p3);
-  strncpy(p3, tmp, p2 - p3);
-  owl_free(tmp);
-  _owl_editwin_set_xy_by_index(e, p3 - e->buff);
+  tmp=e->buff[z];
+  e->buff[z]=e->buff[z-1];
+  e->buff[z-1]=tmp;
+  owl_editwin_key_right(e);
 }
 
@@ -577,16 +495,9 @@
 void owl_editwin_insert_string(owl_editwin *e, char *string)
 {
-  char *p;
-  gunichar c;
-  if (!g_utf8_validate(string, -1, NULL)) {
-    owl_function_debugmsg("owl_editwin_insert_string: received non-utf-8 string.");
-    return;
-  }
-  p = string;
-  c = g_utf8_get_char(p);
-  while (c) {
-    _owl_editwin_process_char(e, c);
-    p = g_utf8_next_char(p);
-    c = g_utf8_get_char(p);
+  int i, j;
+
+  j=strlen(string);
+  for (i=0; i<j; i++) {
+    owl_editwin_insert_char(e, string[i]);
   }
 }
@@ -598,17 +509,9 @@
 void owl_editwin_overwrite_string(owl_editwin *e, char *string)
 {
-  char *p;
-  gunichar c;
-
-  if (!g_utf8_validate(string, -1, NULL)) {
-    owl_function_debugmsg("owl_editwin_overwrite_string: received non-utf-8 string.");
-    return;
-  }
-  p = string;
-  c = g_utf8_get_char(p);
-  while (c) {
-    owl_editwin_overwrite_char(e, c);
-    p = g_utf8_next_char(p);
-    c = g_utf8_get_char(p);
+  int i, j;
+
+  j=strlen(string);
+  for (i=0; i<j; i++) {
+    owl_editwin_overwrite_char(e, string[i]);
   }
 }
@@ -621,106 +524,48 @@
   int i;
   char *ptr1, *ptr2;
-  gunichar c;
-
-  if (e->bufflen == 0) return(0);
+
+  if (e->bufflen==0) return(0);
   
   /* first go to the yth line */
-  ptr1 = e->buff;
-  for (i = 0; i < e->buffy; i++) {
-    ptr2= strchr(ptr1, '\n');
+  ptr1=e->buff;
+  for (i=0; i<e->buffy; i++) {
+    ptr2=strchr(ptr1, '\n');
     if (!ptr2) {
       /* we're already on the last line */
       break;
     }
-    ptr1 = ptr2 + 1;
-  }
-
-  /* now go to the xth cell */
-  ptr2 = ptr1;
-  i = 0;
-  while (ptr2 != NULL && i < e->buffx && (ptr2 - e->buff) < e->bufflen) {
-    c = g_utf8_get_char(ptr2);
-    i += (c == '\n' ? 1 : mk_wcwidth(c));
-    ptr2 = g_utf8_next_char(ptr2);
-  }
-  while(ptr2 != NULL && g_unichar_ismark(g_utf8_get_char(ptr2))) {
-    ptr2 = g_utf8_next_char(ptr2);
-  }
-  if (ptr2 == NULL) return e->bufflen;
-  return(ptr2 - e->buff);
-}
-
-/* We assume x,y are not set to point to a mid-char */
-gunichar _owl_editwin_get_char_at_xy(owl_editwin *e)
-{
-  return g_utf8_get_char(e->buff + _owl_editwin_get_index_from_xy(e));
-}
-
+    ptr1=ptr2+1;
+  }
+
+  /* now go to the xth character */
+  ptr2=strchr(ptr1, '\n');
+  if (!ptr2) {
+    ptr2=e->buff+e->bufflen;
+  }
+
+  if ((ptr2-ptr1) < e->buffx) {
+    ptr1=ptr2-1;
+  } else {
+    ptr1+=e->buffx;
+  }
+
+  /* printf("DEBUG: index is %i\r\n", ptr1-e->buff); */
+  return(ptr1-e->buff);
+}
 
 void _owl_editwin_set_xy_by_index(owl_editwin *e, int index)
 {
-  char *ptr1, *ptr2, *target;
-  gunichar c;
-
-  e->buffx = 0;
-  e->buffy = 0;
-
-  ptr1 = e->buff;
-  target = ptr1 + index;
-  /* target sanitizing */
-  if ((target[0] & 0x80) && (~target[0] & 0x40)) {
-    /* middle of a utf-8 character, back up to previous character. */
-    target = g_utf8_find_prev_char(e->buff, target);
-  }
-  c = g_utf8_get_char(target);
-  while (g_unichar_ismark(c) && target > e->buff) {
-    /* Adjust the target off of combining characters and the like. */
-    target = g_utf8_find_prev_char(e->buff, target);
-    c = g_utf8_get_char(target);
-  }
-  /* If we start with a mark, something is wrong.*/
-  if (g_unichar_ismark(c)) return;
-
-  /* Now our target should be acceptable. */
-  ptr2 = strchr(ptr1, '\n');
-  while (ptr2 != NULL && ptr2 < target) {
-    e->buffy++;
-    ptr1 = ptr2 + 1;
-    ptr2 = strchr(ptr1, '\n');
-  }
-  ptr2 = ptr1;
-  while (ptr2 != NULL && ptr2 < target) {
-    c = g_utf8_get_char(ptr2);
-    e->buffx += mk_wcwidth(c);
-    ptr2 = g_utf8_next_char(ptr2);
-  }
-}
-
-int _owl_editwin_cursor_adjustment(owl_editwin *e)
-{
-  char *ptr1, *ptr2;
-  gunichar c;
-  int x, i;
-
-  /* Find line */
-  ptr1 = e->buff;
-  ptr2 = strchr(ptr1, '\n');
-  for (i = 0; ptr2 != NULL && i < e->buffy; i++) {
-    ptr1 = ptr2 + 1;
-    ptr2 = strchr(ptr1, '\n');
-  }
-  ptr2 = ptr1;
-
-  /* Find char */
-  x = 0;
-  while (ptr2 != NULL && x < e->buffx) {
-    if (*ptr2 == '\n') return 0;
-    c = g_utf8_get_char(ptr2);
-    x += mk_wcwidth(c);
-    ptr2 = g_utf8_next_char(ptr2);
-  }
-  
-  /* calculate x offset */
-  return x - e->buffx;
+  int z, i;
+
+  z=_owl_editwin_get_index_from_xy(e);
+  if (index>z) {
+    for (i=0; i<index-z; i++) {
+      owl_editwin_key_right(e);
+    }
+  } else if (index<z) {
+    for (i=0; i<z-index; i++) {
+      owl_editwin_key_left(e);
+    }
+  }
 }
 
@@ -729,5 +574,5 @@
   /* if we happen to have the cursor over locked text
    * move it to be out of the locktext region */
-  if (_owl_editwin_get_index_from_xy(e) < e->lock) {
+  if (_owl_editwin_get_index_from_xy(e)<e->lock) {
     _owl_editwin_set_xy_by_index(e, e->lock);
   }
@@ -749,6 +594,6 @@
 {
   if (e->buffy > 0) e->buffy--;
-  if (e->buffx >= owl_editwin_get_numcells_on_line(e, e->buffy)) {
-    e->buffx=owl_editwin_get_numcells_on_line(e, e->buffy);
+  if (e->buffx >= owl_editwin_get_numchars_on_line(e, e->buffy)) {
+    e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
   }
 
@@ -767,6 +612,6 @@
 
   /* if we're past the last character move back */
-  if (e->buffx >= owl_editwin_get_numcells_on_line(e, e->buffy)) {
-    e->buffx=owl_editwin_get_numcells_on_line(e, e->buffy);
+  if (e->buffx >= owl_editwin_get_numchars_on_line(e, e->buffy)) {
+    e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
   }
 
@@ -782,17 +627,15 @@
 void owl_editwin_key_left(owl_editwin *e)
 {
-  int i;
-  char * p;
-  i = _owl_editwin_get_index_from_xy(e);
-  p = e->buff + i;
-  p = g_utf8_find_prev_char(e->buff, p);
-  while (p && g_unichar_ismark(g_utf8_get_char(p))) {
-    p = g_utf8_find_prev_char(e->buff, p);
-  }
-  if (p == NULL) p = e->buff;
-  _owl_editwin_set_xy_by_index(e, p - e->buff);
-
-  if (e->buffy - e->topline < 0) {
-    e->topline -= e->winlines / 2;
+  /* move left if we can, and maybe up a line */
+  if (e->buffx>0) {
+    e->buffx--;
+  } else if (e->buffy>0) {
+    e->buffy--;
+    e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
+  }
+
+  /* do we need to scroll up? */
+  if (e->buffy-e->topline < 0) {
+    e->topline-=e->winlines/2;
   }
 
@@ -804,21 +647,20 @@
 {
   int i;
-  char * p;
-  i = _owl_editwin_get_index_from_xy(e);
-  p = e->buff + i;
-  p = g_utf8_find_next_char(p, NULL);
-  while (p && g_unichar_ismark(g_utf8_get_char(p))) {
-    p = g_utf8_find_next_char(p, NULL);
-  }
-  if (p == NULL) {
-    _owl_editwin_set_xy_by_index(e, e->bufflen);
-  }
-  else {
-    _owl_editwin_set_xy_by_index(e, p - e->buff);
+
+  /* move right if we can, and skip down a line if needed */
+  i=owl_editwin_get_numchars_on_line(e, e->buffy);
+  if (e->buffx < i) {
+    e->buffx++;
+    /*  } else if (e->buffy+1 < owl_editwin_get_numlines(e)) { */
+  } else if (_owl_editwin_get_index_from_xy(e) < e->bufflen) {
+    if (e->style==OWL_EDITWIN_STYLE_MULTILINE) {
+      e->buffx=0;
+      e->buffy++;
+    }
   }
 
   /* do we need to scroll down? */
-  if (e->buffy - e->topline >= e->winlines) {
-    e->topline += e->winlines / 2;
+  if (e->buffy-e->topline >= e->winlines) {
+    e->topline+=e->winlines/2;
   }
 }
@@ -827,5 +669,4 @@
 {
   int i, x;
-  gunichar c = '\0';
 
   /* if we're starting on a space, find the first non-space */
@@ -840,14 +681,12 @@
   }
 
-  /* find the next space, newline or end of line and go
-     there, if already at the end of the line, continue on to the next */
-  i=owl_editwin_get_numcells_on_line(e, e->buffy);
-  c = _owl_editwin_get_char_at_xy(e);
+  /* find the next space, newline or end of line and go there, if
+     already at the end of the line, continue on to the next */
+  i=owl_editwin_get_numchars_on_line(e, e->buffy);
   if (e->buffx < i) {
     /* move right till end of line */
     while (e->buffx < i) {
-      owl_editwin_key_right(e);
-      c = _owl_editwin_get_char_at_xy(e);
-      if (c == ' ') return;
+      e->buffx++;
+      if (e->buff[_owl_editwin_get_index_from_xy(e)]==' ') return;
       if (e->buffx == i) return;
     }
@@ -855,5 +694,5 @@
     /* try to move down */
     if (e->style==OWL_EDITWIN_STYLE_MULTILINE) {
-      if (e->buffy+1 < owl_editwin_get_numlines(e)) {
+      if (e->buffy+1 <  owl_editwin_get_numlines(e)) {
 	e->buffx=0;
 	e->buffy++;
@@ -868,42 +707,34 @@
 void owl_editwin_move_to_previousword(owl_editwin *e)
 {
-  int i;
-  gunichar c;
-  char *ptr1, *ptr2;
+  int i, x;
 
   /* are we already at the beginning of the word? */
-  c = _owl_editwin_get_char_at_xy(e);
-  i = _owl_editwin_get_index_from_xy(e);
-  ptr1 = e->buff + i;
-  if (*ptr1 != ' ' && *ptr1 != '\n' && *ptr1 != '\0' ) {
-    ptr1 = g_utf8_find_prev_char(e->buff, ptr1);
-    c = g_utf8_get_char(ptr1);
-    if (c == ' ' || c == '\n') {
-      owl_editwin_key_left(e);      
-    }
-  }
-
+  i=_owl_editwin_get_index_from_xy(e);
+  if ( (e->buff[i]!=' ' && e->buff[i]!='\n' && e->buff[i]!='\0') &&
+       (e->buff[i-1]==' ' || e->buff[i-1]=='\n') ) {
+    owl_editwin_key_left(e);
+  }
+    
   /* are we starting on a space character? */
-  i = _owl_editwin_get_index_from_xy(e);
-  while (e->buff[i] == ' ' || e->buff[i] == '\n' || e->buff[i] == '\0') {
+  i=_owl_editwin_get_index_from_xy(e);
+  if (e->buff[i]==' ' || e->buff[i]=='\n' || e->buff[i]=='\0') {
     /* find the first non-space */
-    owl_editwin_key_left(e);      
-    i = _owl_editwin_get_index_from_xy(e);
+    for (x=i; x>=e->lock; x--) {
+      if (e->buff[x]!=' ' && e->buff[x]!='\n' && e->buff[x]!='\0') {
+	_owl_editwin_set_xy_by_index(e, x);
+	break;
+      }
+    }
   }
 
   /* find the last non-space */
-  owl_editwin_key_left(e);
-  ptr1 = e->buff + _owl_editwin_get_index_from_xy(e);
-  while (ptr1 >= e->buff + e->lock) {
-    ptr2 = g_utf8_find_prev_char(e->buff, ptr1);
-    if (!ptr2) break;
-    
-    c = g_utf8_get_char(ptr2);
-    if (c == ' ' || c == '\n'){
+  i=_owl_editwin_get_index_from_xy(e);
+  for (x=i; x>=e->lock; x--) {
+    if (e->buff[x-1]==' ' || e->buff[x-1]=='\n') {
+      _owl_editwin_set_xy_by_index(e, x);
       break;
     }
-    owl_editwin_key_left(e);
-    ptr1 = e->buff + _owl_editwin_get_index_from_xy(e);
-  }
+  }
+  _owl_editwin_set_xy_by_index(e, x);
 }
 
@@ -911,36 +742,30 @@
 void owl_editwin_delete_nextword(owl_editwin *e)
 {
-  char *ptr1, *start;
-  gunichar c;
+  int z;
 
   if (e->bufflen==0) return;
 
-  start = ptr1 = e->buff + _owl_editwin_get_index_from_xy(e);
-  /* if we start out on a space character then jump past all the
-     spaces up first */
-  while (*ptr1 == ' ' || *ptr1 == '\n') {
-    ++ptr1;
-  }
-
-  /* then jump past the next word */
-  
-  while (ptr1 && ptr1 - e->buff < e->bufflen) {
-    c = g_utf8_get_char(ptr1);
-    if (c == ' ' || c == '\n' || c == '\0') break;
-    ptr1 = g_utf8_find_next_char(ptr1, NULL);
-  }
-
-  if (ptr1) { /* We broke on a space, */
-    ptr1 = g_utf8_find_next_char(ptr1, NULL);
-    if (ptr1) { /* and there's a character after it, */
-      /* nuke everything back to our starting point. */
-      _owl_editwin_remove_bytes(e, ptr1 - start);
-      return;
-    }
-  }
-  
-  /* If we get here, we ran out of string, drop what's left. */
-  *start = '\0';
-  e->bufflen = start - e->buff;
+  /* if we start out on a space character then gobble all the spaces
+     up first */
+  while (1) {
+    z=_owl_editwin_get_index_from_xy(e);
+    if (e->buff[z]==' ' || e->buff[z]=='\n') {
+      owl_editwin_delete_char(e);
+    } else {
+      break;
+    }
+  }
+
+  /* then nuke the next word */
+  while (1) {
+    z=_owl_editwin_get_index_from_xy(e);
+    /* z == e->bufflen check added to prevent a hang I (nelhage) have
+       seen repeatedly while using owl. I'm not sure precisely what
+       conditions lead to it. */
+    if (z == e->bufflen
+        || e->buff[z+1]==' ' || e->buff[z+1]=='\n' || e->buff[z+1]=='\0') break;
+    owl_editwin_delete_char(e);
+  }
+  owl_editwin_delete_char(e);
 }
 
@@ -948,10 +773,12 @@
 {
   /* go backwards to the last non-space character, then delete chars */
-  int startpos, endpos;
+  int i, startpos, endpos;
 
   startpos = _owl_editwin_get_index_from_xy(e);
   owl_editwin_move_to_previousword(e);
   endpos = _owl_editwin_get_index_from_xy(e);
-  _owl_editwin_remove_bytes(e, startpos-endpos);
+  for (i=0; i<startpos-endpos; i++) {
+    owl_editwin_delete_char(e);
+  }
 }
 
@@ -960,5 +787,5 @@
   int i;
 
-  if (owl_editwin_get_numchars_on_line(e, e->buffy) > e->buffx) {
+  if (owl_editwin_get_numchars_on_line(e, e->buffy)>e->buffx) {
     /* normal line */
     i=_owl_editwin_get_index_from_xy(e);
@@ -981,5 +808,5 @@
 void owl_editwin_move_to_line_end(owl_editwin *e)
 {
-  e->buffx=owl_editwin_get_numcells_on_line(e, e->buffy);
+  e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
 }
 
@@ -994,5 +821,5 @@
   /* go to last char */
   e->buffy=owl_editwin_get_numlines(e)-1;
-  e->buffx=owl_editwin_get_numcells_on_line(e, e->buffy);
+  e->buffx=owl_editwin_get_numchars_on_line(e, e->buffy);
   owl_editwin_key_right(e);
 
@@ -1034,45 +861,38 @@
   /* main loop */
   while (1) {
-    i = _owl_editwin_get_index_from_xy(e);
+    i=_owl_editwin_get_index_from_xy(e);
 
     /* bail if we hit the end of the buffer */
-    if (i >= e->bufflen || e->buff[i] == '\0') break;
+    if (i>=e->bufflen) break;
 
     /* bail if we hit the end of the paragraph */
-    if (e->buff[i] == '\n' && e->buff[i+1] == '\n') break;
+    if (e->buff[i]=='\n' && e->buff[i+1]=='\n') break;
 
     /* if we've travelled too far, linewrap */
     if ((e->buffx) >= e->fillcol) {
-      int len = e->bufflen;
       _owl_editwin_linewrap_word(e);
-      /* we may have added a character. */
-      if (i < save) save += e->bufflen - len;
     }
 
     /* did we hit the end of a line too soon? */
-    /* asedeno: Here we replace a newline with a space. We may want to
-       consider removing the space if the characters to either side
-       are CJK ideograms.*/
-    i = _owl_editwin_get_index_from_xy(e);
-    if (e->buff[i] == '\n' && e->buffx < e->fillcol - 1) {
+    i=_owl_editwin_get_index_from_xy(e);
+    if (e->buff[i]=='\n' && e->buffx<e->fillcol-1) {
       /* ********* we need to make sure we don't pull in a word that's too long ***********/
       e->buff[i]=' ';
     }
-
+    
     /* fix spacing */
-    i = _owl_editwin_get_index_from_xy(e);
-    if (e->buff[i] == ' ' && e->buff[i+1] == ' ') {
-      if (e->buff[i-1] == '.' || e->buff[i-1] == '!' || e->buff[i-1] == '?') {
+    i=_owl_editwin_get_index_from_xy(e);
+    if (e->buff[i]==' ' && e->buff[i+1]==' ') {
+      if (e->buff[i-1]=='.' || e->buff[i-1]=='!' || e->buff[i-1]=='?') {
 	owl_editwin_key_right(e);
       } else {
 	owl_editwin_delete_char(e);
-	/* if we did this ahead of the save point, adjust it. Changing
-           by one is fine here because we're only removing an ASCII
-           space. */
-	if (i < save) save--;
+	/* if we did this ahead of the save point, adjust it */
+	if (i<save) save--;
       }
     } else {
       owl_editwin_key_right(e);
     }
+
   }
 
@@ -1095,31 +915,23 @@
 int owl_editwin_check_dotsend(owl_editwin *e)
 {
-  char *p, *p_n, *p_p;
-  gunichar c;
+  int i;
 
   if (!e->dotsend) return(0);
-
-  p = g_utf8_find_prev_char(e->buff, e->buff + e->bufflen);
-  p_n = g_utf8_find_next_char(p, NULL);
-  p_p = g_utf8_find_prev_char(e->buff, p);
-  c = g_utf8_get_char(p);
-  while (p != NULL) {
-    if (*p == '.'
-	&& p_p != NULL && (*p_p == '\n' || *p_p == '\r')
-	&& p_n != NULL && (*p_n == '\n' || *p_n == '\r')) {
-      e->bufflen = p - e->buff;
-      e->buff[e->bufflen] = '\0';
+  for (i=e->bufflen-1; i>0; i--) {
+    if (e->buff[i] == '.' 
+	&& (e->buff[i-1] == '\n' || e->buff[i-1] == '\r')
+	&& (e->buff[i+1] == '\n' || e->buff[i+1] == '\r')) {
+      e->bufflen = i;
+      e->buff[i] = '\0';
       return(1);
     }
-    if (c != '\0' && !g_unichar_isspace(c)) return(0);
-    p_n = p;
-    p = p_p;
-    c = g_utf8_get_char(p);
-    p_p = g_utf8_find_prev_char(e->buff, p);
+    if (!isspace((int) e->buff[i])) {
+      return(0);
+    }
   }
   return(0);
 }
 
-void owl_editwin_post_process_char(owl_editwin *e, owl_input j)
+void owl_editwin_post_process_char(owl_editwin *e, int j)
 {
   /* check if we need to scroll down */
@@ -1127,5 +939,5 @@
     e->topline+=e->winlines/2;
   }
-  if ((j.ch==13 || j.ch==10) && owl_editwin_check_dotsend(e)) {
+  if ((j==13 || j==10) && owl_editwin_check_dotsend(e)) {
     owl_command_editmulti_done(e);
     return;
@@ -1134,18 +946,11 @@
 }
 
-void _owl_editwin_process_char(owl_editwin *e, gunichar j)
-{
-  if (!(g_unichar_iscntrl(j) && (j != 10) && (j != 13))) {
+void owl_editwin_process_char(owl_editwin *e, int j)
+{
+  if (j == ERR) return;
+  if (j>127 || ((j<32) && (j!=10) && (j!=13))) {
+    return;
+  } else {
     owl_editwin_insert_char(e, j);
-  }
-}
-
-
-void owl_editwin_process_char(owl_editwin *e, owl_input j)
-{
-  if (j.ch == ERR) return;
-  /* Ignore ncurses control characters. */
-  if (j.ch < 0x100) { 
-    _owl_editwin_process_char(e, j.uch);
   }
 }
@@ -1174,44 +979,10 @@
   }
 
-  /* now count characters */
-  i = 0;
-  ptr2 = ptr1;
-  while (ptr2 - e->buff < e->bufflen
-	 && *ptr2 != '\n') {
-    ++i;
-    ptr2 = g_utf8_next_char(ptr2);
-  }
-  return i;
-}
-
-int owl_editwin_get_numcells_on_line(owl_editwin *e, int line)
-{
-  int i;
-  char *ptr1, *ptr2;
-  gunichar c;
-
-  if (e->bufflen==0) return(0);
-  
-  /* first go to the yth line */
-  ptr1=e->buff;
-  for (i=0; i<line; i++) {
-    ptr2=strchr(ptr1, '\n');
-    if (!ptr2) {
-      /* we're already on the last line */
-      return(0);
-    }
-    ptr1=ptr2+1;
-  }
-
-  /* now count cells */
-  i = 0;
-  ptr2 = ptr1;
-  while (ptr2 - e->buff < e->bufflen
-	 && *ptr2 != '\n') {
-    c = g_utf8_get_char(ptr2);
-    i += mk_wcwidth(c);
-    ptr2 = g_utf8_next_char(ptr2);
-  }
-  return i;
+  /* now go to the xth character */
+  ptr2=strchr(ptr1, '\n');
+  if (!ptr2) {
+    return(e->buff + e->bufflen - ptr1);
+  }
+  return(ptr2-ptr1); /* don't count the newline for now */
 }
 
